Index: test/rotated_text.cxx
===================================================================
--- test/rotated_text.cxx	(revision 10650)
+++ test/rotated_text.cxx	(working copy)
@@ -38,6 +38,37 @@
 Fl_Hor_Value_Slider *angles;
 Fl_Double_Window *window;
 
+
+#include "config.h"
+#if defined(USE_X11) && defined(USE_XFT)
+#include <FL/x.H>
+#include <src/Fl_Font.H>
+extern "C" {
+  void XftFontClose(Display*, void*);
+}
+#endif
+
+void delete_rotated_font(Fl_Font num, int angle, int size)
+{
+#if defined(USE_X11) && defined(USE_XFT)
+  Fl_Fontdesc *font = fl_fonts + num;
+  Fl_Font_Descriptor *f = font->first, *previous = NULL;
+  while (f) {
+    if (f->size == size && f->angle == angle) break;
+    previous = f;
+    f = f->next;
+  }
+  if (!f) return;
+  if (!previous) {
+    font->first = f->next;
+  } else {
+    previous->next = f->next;
+  }
+  delete f;
+  XftFontClose(fl_display, f->font);
+#endif
+}
+
 //code taken from fl_engraved_label.cxx
 class Rotated_Label_Box : public Fl_Widget{
   protected:
@@ -127,6 +158,7 @@
   window->redraw();
 }
 void angle_cb(Fl_Widget *,void *) {
+  delete_rotated_font(text->labelfont(), text->rt_angle, text->labelsize());
   text->rt_angle=(int)angles->value();
   window->redraw();
 }
